/* 
 *   Creation Date: <1999/03/29 05:04:40 samuel>
 *   Time-stamp: <2001/12/28 19:21:23 samuel>
 *   
 *	<long_lseek.h>
 *	
 *	64bit lseek
 *   
 *   Copyright (C) 1999, 2000, 2001 Samuel Rydh (samuel@ibrium.se)
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation
 *   
 */

#ifndef _H_LONG_LSEEK
#define _H_LONG_LSEEK

#include <unistd.h>

#ifdef __linux__
#include <linux/unistd.h>
extern int _llseek( uint fd, ulong offs_hi, ulong offs_lo, loff_t *res, uint wh );
#endif

static inline int 
long_lseek( int fd, ulong pos_hi, ulong pos_lo )
{
#ifdef OFF_T_IS_64
	return lseek( fd, TO_LLONG( pos_hi, pos_lo), SEEK_SET ) == -1 ? -1 : 0;
#else
	loff_t res;
	return _llseek( fd, pos_hi, pos_lo, &res, SEEK_SET );
#endif
}

static inline int
blk_lseek( int fd, long block, long offs )
{
#ifndef OFF_T_IS_64
	loff_t res;
#endif
	if( offs & ~0x1ff ) {
		printm("blk_lseek: offs out of range\n");
		return -2;
	}
#ifdef OFF_T_IS_64
	return lseek( fd, ((llong)block<<9) | offs, SEEK_SET ) == -1 ? -1 : 0;
#else
	return _llseek( fd, (block>>23), (block<<9) | offs, &res, SEEK_SET );
#endif
}

static inline llong ltell( int fd ) {
#ifdef OFF_T_IS_64
	return lseek( fd, 0, SEEK_CUR );
#else
	loff_t res;
	if( _llseek( fd, 0, 0, &res, SEEK_CUR ) < 0 )
		return -1;
	return res;
#endif
}

/* util */
extern ulong get_file_size_in_blks( int fd );

#endif   /* _H_LONG_LSEEK */
